---
layout: page
mathjax: true
---

## Overview

Download the assignment file [`assignment2.zip`](http://www.cs.princeton.edu/courses/archive/spring18/cos495/releases/assignment2.zip).

This assignment consists of a part on word vectors and a part on RNNs:
* word vectors (inside `wordvec`)
  * `imdb_glove.ipynb`: train glove and LSA, test on supervised sentiment classification
  * `commoncrawl_glove.ipynb`: evaluate word representations

The respective notebooks contain more detailed instructions and inline questions.

After you downloaded and unzipped `assignment2.zip`:
* run `jupyter notebook` in the assignment folder

### Submitting your work:
Once you are done
working run the `collectSubmission.sh` script; this will produce a file called
`assignment2.zip`. Submit this to the class Dropbox.

The written part should be included, either in the notebook, or as a separate file.
If you worked with a partner, please submit one answer (unless you substantially disagree on it).
Include the ids of both partners.

### Download data:
Run the `git clone https://github.com/cos495nlp/data` from the `assignment2` directory.

### Start IPython:
You should start the IPython notebook server from the
`assignment2` directory, with the `jupyter notebook` command.
