import sys
from collections import defaultdict
from random import shuffle
import numpy as np
np.seterr(all='raise')

FLOAT = np.float32

def write(msg):
    ''' writes input to stdout
    Args:
        msg: string
    Returns:
        None
    '''
    sys.stdout.write(msg)
    sys.stdout.flush()


def count_cooccurrences(documents, vocab, window_size=8):
    ''' counts word-word co-occurrences in corpus
    Args:
        documents: list of lists of tokens
        vocab: dict mapping words to unique indices
        window_size: size of context window
    Returns:
        dict mapping pairs of words to real numbers
    '''

    cooc_counts = defaultdict(lambda: 0.0)
    for i, document in enumerate(documents):
        ####################################
        # TODO: cooccurrence window update #
        # add weighted cooccurrence for each
        # co-occurring word-pair in document
        ####################################
        # BEGIN_YOUR_CODE (around 10 lines of code expected)
        raise Exception("Not implemented yet")
        # END_YOUR_CODE
        ####################################
        if not (i+1)%100:
            write('\rProcessed '+str(i+1)+'/'+str(len(documents))+' Documents')
    write('\rCollected '+str(len(cooc_counts))+' Cooccurrence Pairs\n')
    return cooc_counts


def optimize_objective(cooc_list, vocab_size, dimension=300, n_epochs=10, eta=0.1, x_max=100.0, alpha=0.75):
    ''' computes GloVe embeddings
    Args:
        cooc_list: list of (word, word, float) co-occurrence triples
        vocab_size: number of words in vocabulary
        dimension: output embedding dimension
        n_epochs: number of epochs of SGD
        eta: SGD learning rate
        x_max: co-occurrence weight function parameter
        alpha: co-occurrence weight function parameter
    Returns:
        dense vocab_size by dimension matrix
    '''

    word_vectors = ((np.random.rand(vocab_size, dimension)-0.5) / dimension).astype(FLOAT)
    context_vectors = ((np.random.rand(vocab_size, dimension)-0.5) / dimension).astype(FLOAT)
    word_biases = ((np.random.rand(vocab_size)-0.5) / dimension).astype(FLOAT)
    context_biases = ((np.random.rand(vocab_size)-0.5) / dimension).astype(FLOAT)

    for epoch in range(n_epochs):
        write('Shuffling')
        shuffle(cooc_list)
        root = '\rEpoch '+str(epoch+1)+': '
        loss = 0.0
        for cooc, (i, j, xij) in enumerate(cooc_list):
            ##########################################
            # TODO: stochastic gradient step  ########
            # update parameters for given co-occurence
            # update loss using given co-occurrence ##
            ##########################################
            # BEGIN_YOUR_CODE (around 15 lines of code expected)
            raise Exception("Not implemented yet")
            # END_YOUR_CODE
            ##########################################
            if not (cooc+1)%10000:
                write(root+str(cooc+1))
        write(root+'Loss='+str(loss)+'\n')

    return word_vectors


def represent_documents(documents, w2v, dimension=300):
    ''' computes document representations by summation
    Args:
        documents: list of lists of tokens
        w2v: dict mapping words to vectors
        dimension: embedding dimension
    Returns:
        dense len(documents) by dimension matrix
    '''

    zero_vector = np.zeros(dimension, dtype=FLOAT)
    ####################################
    # TODO: sum-of-vectors embedding ###
    # compute matrix of representations
    ####################################
    # BEGIN_YOUR_CODE (around 1 line of code expected)
    raise Exception("Not implemented yet")
    # END_YOUR_CODE
    ####################################
